//--- import trade.mqh
#include <Trade\Trade.mqh>

// Crear una instancia de CTrade
CTrade  trade;

// Standard things
input int                  TiempoOperacion      =  36;        // Tiempo de operacion


void OnTick()
  {
   // tomar el precio ASK
   double Ask=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   
   // tomar el precio BID
   double Bid=NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
   
   // Si no hay posiciones abiertas
   if (PositionsTotal()==0)
      {
        // abre posiciones de prueba
        //trade.Buy(0.10,NULL,Ask,(Ask-1000*_Point),(Ask+150-_Point),NULL);
        //trade.Sell(0.10,NULL,Bid,(Bid+1000*_Point),(Bid-150*_Point),NULL);
      }  
   
   // Check el CloseTimer
   CheckCloseTimer();
   
   }
  
//+------------------------------------------------------------------+
void CheckCloseTimer()
   {
    // cuenta las posiciones abiertas
    for (int i=PositionsTotal()-1;i>=0; i--)
      {
         // toma el numero de la posicion
         int ticket=PositionGetTicket(i);
         
         //toma la hora de apertura de la posicion
         datetime PositionOpenTime=PositionGetInteger(POSITION_TIME);
         
         //Crea la estructura para la hora de apertura
         MqlDateTime MyOpenTime;
         
         //Convierte el tiempo de apertura a la estructura
         TimeToStruct(PositionOpenTime, MyOpenTime);
         
         //Toma la hora de apertura
         int OpeningSec=MyOpenTime.sec; // cambiar por segundos
         
         
         //Toma la hora local
         datetime LocalTime=TimeLocal();
         
         //Crea la estructura para la hora actual
         MqlDateTime MyLocalTime;
         
         // Convierte la hora actual a la estructura
         TimeToStruct(LocalTime,MyLocalTime);
         
         // toma la hora actual
         int CurrentSec= MyLocalTime.sec; // cambiar por segundos
         
         
         // Calcula la diferencia
         int Diferencia= CurrentSec-OpeningSec;

         
         // Impresion
         Print("+++ Posicion:    ", ticket);
         Print("+++ Apertura:    ", PositionOpenTime);
         Print("+++ Hora actual: ", LocalTime);
         Print("+++ Diferencia:  ", Diferencia);
         
         double PositionProfit = PositionGetDouble(POSITION_PROFIT);
         
         // Despues de X horas
         if (Diferencia > (TiempoOperacion-1))
         
         // Si el profit es negativo
         //  if (PositionProfit<0) simpre lo debe cerrar
         {
           //Cierra la posicion
           trade.PositionClose(ticket);
         }
      }   
   }